/* ***********************************************************
 * This file was automatically generated on 2024-02-27.      *
 *                                                           *
 * Rust Bindings Version 2.0.21                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Measures Voltage, Current, Energy, Real/Apparent/Reactive Power, Power Factor and Frequency.
//!
//! See also the documentation [here](https://www.tinkerforge.com/en/doc/Software/Bricklets/EnergyMonitor_Bricklet_Rust.html).
use crate::{
    byte_converter::*,
    converting_callback_receiver::ConvertingCallbackReceiver,
    converting_receiver::{BrickletRecvTimeoutError, ConvertingReceiver},
    device::*,
    ip_connection::GetRequestSender,
    low_level_traits::*,
};
pub enum EnergyMonitorBrickletFunction {
    GetEnergyData,
    ResetEnergy,
    GetWaveformLowLevel,
    GetTransformerStatus,
    SetTransformerCalibration,
    GetTransformerCalibration,
    CalibrateOffset,
    SetEnergyDataCallbackConfiguration,
    GetEnergyDataCallbackConfiguration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackEnergyData,
}
impl From<EnergyMonitorBrickletFunction> for u8 {
    fn from(fun: EnergyMonitorBrickletFunction) -> Self {
        match fun {
            EnergyMonitorBrickletFunction::GetEnergyData => 1,
            EnergyMonitorBrickletFunction::ResetEnergy => 2,
            EnergyMonitorBrickletFunction::GetWaveformLowLevel => 3,
            EnergyMonitorBrickletFunction::GetTransformerStatus => 4,
            EnergyMonitorBrickletFunction::SetTransformerCalibration => 5,
            EnergyMonitorBrickletFunction::GetTransformerCalibration => 6,
            EnergyMonitorBrickletFunction::CalibrateOffset => 7,
            EnergyMonitorBrickletFunction::SetEnergyDataCallbackConfiguration => 8,
            EnergyMonitorBrickletFunction::GetEnergyDataCallbackConfiguration => 9,
            EnergyMonitorBrickletFunction::GetSpitfpErrorCount => 234,
            EnergyMonitorBrickletFunction::SetBootloaderMode => 235,
            EnergyMonitorBrickletFunction::GetBootloaderMode => 236,
            EnergyMonitorBrickletFunction::SetWriteFirmwarePointer => 237,
            EnergyMonitorBrickletFunction::WriteFirmware => 238,
            EnergyMonitorBrickletFunction::SetStatusLedConfig => 239,
            EnergyMonitorBrickletFunction::GetStatusLedConfig => 240,
            EnergyMonitorBrickletFunction::GetChipTemperature => 242,
            EnergyMonitorBrickletFunction::Reset => 243,
            EnergyMonitorBrickletFunction::WriteUid => 248,
            EnergyMonitorBrickletFunction::ReadUid => 249,
            EnergyMonitorBrickletFunction::GetIdentity => 255,
            EnergyMonitorBrickletFunction::CallbackEnergyData => 10,
        }
    }
}
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct EnergyData {
    pub voltage: i32,
    pub current: i32,
    pub energy: i32,
    pub real_power: i32,
    pub apparent_power: i32,
    pub reactive_power: i32,
    pub power_factor: u16,
    pub frequency: u16,
}
impl FromByteSlice for EnergyData {
    fn bytes_expected() -> usize { 28 }
    fn from_le_byte_slice(bytes: &[u8]) -> EnergyData {
        EnergyData {
            voltage: <i32>::from_le_byte_slice(&bytes[0..4]),
            current: <i32>::from_le_byte_slice(&bytes[4..8]),
            energy: <i32>::from_le_byte_slice(&bytes[8..12]),
            real_power: <i32>::from_le_byte_slice(&bytes[12..16]),
            apparent_power: <i32>::from_le_byte_slice(&bytes[16..20]),
            reactive_power: <i32>::from_le_byte_slice(&bytes[20..24]),
            power_factor: <u16>::from_le_byte_slice(&bytes[24..26]),
            frequency: <u16>::from_le_byte_slice(&bytes[26..28]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct WaveformLowLevel {
    pub waveform_chunk_offset: u16,
    pub waveform_chunk_data: [i16; 30],
}
impl FromByteSlice for WaveformLowLevel {
    fn bytes_expected() -> usize { 62 }
    fn from_le_byte_slice(bytes: &[u8]) -> WaveformLowLevel {
        WaveformLowLevel {
            waveform_chunk_offset: <u16>::from_le_byte_slice(&bytes[0..2]),
            waveform_chunk_data: <[i16; 30]>::from_le_byte_slice(&bytes[2..62]),
        }
    }
}
impl LowLevelRead<i16, WaveformResult> for WaveformLowLevel {
    fn ll_message_length(&self) -> usize { 1536 }

    fn ll_message_chunk_offset(&self) -> usize { self.waveform_chunk_offset as usize }

    fn ll_message_chunk_data(&self) -> &[i16] { &self.waveform_chunk_data }

    fn get_result(&self) -> WaveformResult { WaveformResult {} }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TransformerStatus {
    pub voltage_transformer_connected: bool,
    pub current_transformer_connected: bool,
}
impl FromByteSlice for TransformerStatus {
    fn bytes_expected() -> usize { 2 }
    fn from_le_byte_slice(bytes: &[u8]) -> TransformerStatus {
        TransformerStatus {
            voltage_transformer_connected: <bool>::from_le_byte_slice(&bytes[0..1]),
            current_transformer_connected: <bool>::from_le_byte_slice(&bytes[1..2]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TransformerCalibration {
    pub voltage_ratio: u16,
    pub current_ratio: u16,
    pub phase_shift: i16,
}
impl FromByteSlice for TransformerCalibration {
    fn bytes_expected() -> usize { 6 }
    fn from_le_byte_slice(bytes: &[u8]) -> TransformerCalibration {
        TransformerCalibration {
            voltage_ratio: <u16>::from_le_byte_slice(&bytes[0..2]),
            current_ratio: <u16>::from_le_byte_slice(&bytes[2..4]),
            phase_shift: <i16>::from_le_byte_slice(&bytes[4..6]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct EnergyDataCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
}
impl FromByteSlice for EnergyDataCallbackConfiguration {
    fn bytes_expected() -> usize { 5 }
    fn from_le_byte_slice(bytes: &[u8]) -> EnergyDataCallbackConfiguration {
        EnergyDataCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct EnergyDataEvent {
    pub voltage: i32,
    pub current: i32,
    pub energy: i32,
    pub real_power: i32,
    pub apparent_power: i32,
    pub reactive_power: i32,
    pub power_factor: u16,
    pub frequency: u16,
}
impl FromByteSlice for EnergyDataEvent {
    fn bytes_expected() -> usize { 28 }
    fn from_le_byte_slice(bytes: &[u8]) -> EnergyDataEvent {
        EnergyDataEvent {
            voltage: <i32>::from_le_byte_slice(&bytes[0..4]),
            current: <i32>::from_le_byte_slice(&bytes[4..8]),
            energy: <i32>::from_le_byte_slice(&bytes[8..12]),
            real_power: <i32>::from_le_byte_slice(&bytes[12..16]),
            apparent_power: <i32>::from_le_byte_slice(&bytes[16..20]),
            reactive_power: <i32>::from_le_byte_slice(&bytes[20..24]),
            power_factor: <u16>::from_le_byte_slice(&bytes[24..26]),
            frequency: <u16>::from_le_byte_slice(&bytes[26..28]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize { 16 }
    fn from_le_byte_slice(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_byte_slice(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_byte_slice(&bytes[4..8]),
            error_count_frame: <u32>::from_le_byte_slice(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_byte_slice(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_byte_slice(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_byte_slice(&bytes[0..8]),
            connected_uid: <String>::from_le_byte_slice(&bytes[8..16]),
            position: <char>::from_le_byte_slice(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_byte_slice(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_byte_slice(&bytes[20..23]),
            device_identifier: <u16>::from_le_byte_slice(&bytes[23..25]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct WaveformResult {}

/// Measures Voltage, Current, Energy, Real/Apparent/Reactive Power, Power Factor and Frequency
#[derive(Clone)]
pub struct EnergyMonitorBricklet {
    device: Device,
}
impl EnergyMonitorBricklet {
    pub const DEVICE_IDENTIFIER: u16 = 2152;
    pub const DEVICE_DISPLAY_NAME: &'static str = "Energy Monitor Bricklet";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new<T: GetRequestSender>(uid: &str, req_sender: T) -> EnergyMonitorBricklet {
        let mut result = EnergyMonitorBricklet { device: Device::new([2, 0, 0], uid, req_sender, 1) };
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetEnergyData) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::ResetEnergy) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetWaveformLowLevel) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetTransformerStatus) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::SetTransformerCalibration) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetTransformerCalibration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::CalibrateOffset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::SetEnergyDataCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetEnergyDataCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::SetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::WriteFirmware) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::SetStatusLedConfig) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(EnergyMonitorBrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::energy_monitor_bricklet::EnergyMonitorBricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is sent
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::energy_monitor_bricklet::EnergyMonitorBricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: EnergyMonitorBrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is sent
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: EnergyMonitorBrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// Returns the version of the API definition (major, minor, revision) implemented by this API bindings.
    /// This is neither the release version of this API bindings nor does it tell you anything about the represented Brick or Bricklet.
    pub fn get_api_version(&self) -> [u8; 3] { self.device.api_version }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_energy_data_callback_configuration`].
    ///
    /// The parameters are the same as [`get_energy_data`].
    ///
    /// [`get_energy_data`]: #method.get_energy_data
    /// [`set_energy_data_callback_configuration`]: #method.set_energy_data_callback_configuration
    pub fn get_energy_data_callback_receiver(&self) -> ConvertingCallbackReceiver<EnergyDataEvent> {
        self.device.get_callback_receiver(u8::from(EnergyMonitorBrickletFunction::CallbackEnergyData))
    }

    /// Returns all of the measurements that are done by the Energy Monitor Bricklet.
    ///
    /// * Voltage RMS
    /// * Current RMS
    /// * Energy (integrated over time)
    /// * Real Power
    /// * Apparent Power
    /// * Reactive Power
    /// * Power Factor
    /// * Frequency (AC Frequency of the mains voltage)
    ///
    /// The frequency is recalculated every 6 seconds.
    ///
    /// All other values are integrated over 10 zero-crossings of the voltage sine wave.
    /// With a standard AC mains voltage frequency of 50Hz this results in a 5 measurements
    /// per second (or an integration time of 200ms per measurement).
    ///
    /// If no voltage transformer is connected, the Bricklet will use the current waveform
    /// to calculate the frequency and it will use an integration time of
    /// 10 zero-crossings of the current waveform.
    pub fn get_energy_data(&self) -> ConvertingReceiver<EnergyData> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetEnergyData), payload)
    }

    /// Sets the energy value (see [`get_energy_data`]) back to 0Wh.
    pub fn reset_energy(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(EnergyMonitorBrickletFunction::ResetEnergy), payload)
    }

    /// Returns a snapshot of the voltage and current waveform. The values
    /// in the returned array alternate between voltage and current. The data from
    /// one getter call contains 768 data points for voltage and current, which
    /// correspond to about 3 full sine waves.
    ///
    /// The voltage is given with a resolution of 100mV and the current is given
    /// with a resolution of 10mA.
    ///
    /// This data is meant to be used for a non-realtime graphical representation of
    /// the voltage and current waveforms.
    pub fn get_waveform_low_level(&self) -> ConvertingReceiver<WaveformLowLevel> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetWaveformLowLevel), payload)
    }

    /// Returns a snapshot of the voltage and current waveform. The values
    /// in the returned array alternate between voltage and current. The data from
    /// one getter call contains 768 data points for voltage and current, which
    /// correspond to about 3 full sine waves.
    ///
    /// The voltage is given with a resolution of 100mV and the current is given
    /// with a resolution of 10mA.
    ///
    /// This data is meant to be used for a non-realtime graphical representation of
    /// the voltage and current waveforms.
    pub fn get_waveform(&self) -> Result<Vec<i16>, BrickletRecvTimeoutError> {
        let ll_result = self.device.get_high_level(0, &mut || self.get_waveform_low_level().recv())?;
        Ok(ll_result.0)
    }

    /// Returns *true* if a voltage/current transformer is connected to the Bricklet.
    pub fn get_transformer_status(&self) -> ConvertingReceiver<TransformerStatus> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetTransformerStatus), payload)
    }

    /// Sets the transformer ratio for the voltage and current transformer in 1/100 form.
    ///
    /// Example: If your mains voltage is 230V, you use 9V voltage transformer and a
    /// 1V:30A current clamp your voltage ratio is 230/9 = 25.56 and your current ratio
    /// is 30/1 = 30.
    ///
    /// In this case you have to set the values 2556 and 3000 for voltage ratio and current
    /// ratio.
    ///
    /// The calibration is saved in non-volatile memory, you only have to set it once.
    ///
    /// Set the phase shift to 0. It is for future use and currently not supported by the Bricklet.
    pub fn set_transformer_calibration(&self, voltage_ratio: u16, current_ratio: u16, phase_shift: i16) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 6];
        payload[0..2].copy_from_slice(&<u16>::to_le_byte_vec(voltage_ratio));
        payload[2..4].copy_from_slice(&<u16>::to_le_byte_vec(current_ratio));
        payload[4..6].copy_from_slice(&<i16>::to_le_byte_vec(phase_shift));

        self.device.set(u8::from(EnergyMonitorBrickletFunction::SetTransformerCalibration), payload)
    }

    /// Returns the transformer calibration as set by [`set_transformer_calibration`].
    pub fn get_transformer_calibration(&self) -> ConvertingReceiver<TransformerCalibration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetTransformerCalibration), payload)
    }

    /// Calling this function will start an offset calibration. The offset calibration will
    /// integrate the voltage and current waveform over a longer time period to find the 0
    /// transition point in the sine wave.
    ///
    /// The Bricklet comes with a factory-calibrated offset value, you should not have to
    /// call this function.
    ///
    /// If you want to re-calibrate the offset we recommend that you connect a load that
    /// has a smooth sinusoidal voltage and current waveform. Alternatively you can also
    /// short both inputs.
    ///
    /// The calibration is saved in non-volatile memory, you only have to set it once.
    pub fn calibrate_offset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(EnergyMonitorBrickletFunction::CalibrateOffset), payload)
    }

    /// The period is the period with which the [`get_energy_data_callback_receiver`]
    /// receiver is triggered periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change within the
    /// period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    pub fn set_energy_data_callback_configuration(&self, period: u32, value_has_to_change: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 5];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));

        self.device.set(u8::from(EnergyMonitorBrickletFunction::SetEnergyDataCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by
    /// [`set_energy_data_callback_configuration`].
    pub fn get_energy_data_callback_configuration(&self) -> ConvertingReceiver<EnergyDataCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetEnergyDataCallbackConfiguration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_OK
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(mode));

        self.device.get(u8::from(EnergyMonitorBrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see [`set_bootloader_mode`].
    ///
    /// Associated constants:
    /// * ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* ENERGY_MONITOR_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for [`write_firmware`]. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(pointer));

        self.device.set(u8::from(EnergyMonitorBrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// [`set_write_firmware_pointer`] before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_byte_vec(data));

        self.device.get(u8::from(EnergyMonitorBrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(config));

        self.device.set(u8::from(EnergyMonitorBrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by [`set_status_led_config`]
    ///
    /// Associated constants:
    /// * ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* ENERGY_MONITOR_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(EnergyMonitorBrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(uid));

        self.device.set(u8::from(EnergyMonitorBrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    /// A Bricklet connected to an [Isolator Bricklet](isolator_bricklet) is always at
    /// position 'z'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(EnergyMonitorBrickletFunction::GetIdentity), payload)
    }
}
